! @(#)descr.prg	15.1.1.1 (ESO-DMD) 01/12/01 16:50:12
! ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
! MIDAS procedure  descr.prg  to implement
!                             DELETE, PRINT, READ, SHOW, WRITE/DESCR
! K. Banse	910228, 920207, 930316, 990120
!
! execute via DELETE/DESCR frame descr stop_flag
! or          READ/DESCR frame descr_list display_flag
!             PRINT/DESCR frame descr_list display_flag
!             WRITE/DESCR frame descr data [ALL]
!             SHOW/DESCR frame descr_list display_flag
!
! ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
define/param p1 ? ima "Enter frame name:"
branch mid$cmnd(1:1) r,w,p,s read,write,read,show
! 
! fall through to DELETE/DESCR
define/param p2 ? c "Enter descriptor name:"
define/param p3 Yes c "Enter stop_flag:"
define/maxpar 3
goto run_it
! 
! READ/DESCR
read:
inputi = m$index(p1,".tbl")
if inputi .gt. 1 then
   define/param p2 tblength,tbloffst,tblcontr,tseltabl c -
                 "Enter descriptor names(s): "
else
   define/param p2 naxis,npix,start,step,ident,cunit,lhcuts c -
                 "Enter descriptor names(s): "
endif
define/param p3 Brief ? "Enter display flag (Full or Brief):"
define/maxpar 3
goto run_it
! 
! WRITE/DESCR
write:
define/param p2 ? c "Enter descriptor name:"
define/param p3 + c "Enter descriptor data:"
define/param p4 no c "Enter ALL flag (All or NoAll):"
define/maxpar 4
goto run_it
! 
! SHOW/DESCR
show:
define/param p2 * c "Enter descriptor name(s):"
define/param p3 Full ? "Enter display flag (Full or Hidden):"
define/maxpar 3
!
run_it:
write/keyw in_a {p1}
write/keyw action {mid$cmnd(1:1)}{p3(1:1)}
!
if mid$cmnd(1:1) .eq. "P" @ print.prg assign
run MID_EXE:descr
if mid$cmnd(1:1) .eq. "P" @ print.prg out
